<?php

namespace App\Console\Commands;

use App\Core\Elastic\IndexerFactory;
use App\Core\Elastic\IndexFactory;
use App\Core\Elastic\ScheduleRunner;
use Elasticsearch\Client;
use Illuminate\Console\Command;
use Illuminated\Console\WithoutOverlapping;

/**
 * Class ElasticRun
 * @package App\Console\Commands
 */
class ElasticRun extends Command
{
    use WithoutOverlapping;

    protected $signature = 'elastic:run';
    protected $description = 'Run indexation';

    public function handle(IndexerFactory $indexerFactory): int
    {
        ini_set('memory_limit', '10G');

        try {
            $scheduler = new ScheduleRunner();
            $scheduler->workOnMarked($indexerFactory);
        } catch (\Exception $e) {
            $this->error($e->getMessage());

            return 1;
        }
        $this->info('Success');

        return 0;
    }
}
