<?php

namespace App\Core\Elastic\Category;

use App\Core\Elastic\Indexer;
use App\Domain\Categories\Models\Category;

class CategoryIndexer implements Indexer
{
    /** @var CategoryIndex */
    private $index;

    public function __construct(CategoryIndex $index)
    {
        $this->index = $index;
    }

    public function index(int $id): bool
    {
        /** @var Category $category */
        $category = Category::query()->where('id', $id)->select(['id', 'name'])->first();
        if (!$category) {
            return false;
        }

        $this->index->upsert($category->id, $category->name);

        return true;
    }

    public function preload(array $ids)
    {
    }
}
