<?php

namespace App\Core\Elastic\Product\Indexing;

use App\Core\Elastic\Product\OfferIndexProperty;
use App\Domain\Products\Models\Product;

class OfferTicket
{
    public function __construct(public int $id, public OfferIndexProperty $target, public Product $product)
    {
    }

    public static function create(int $id, ProductTicket $productTicket): static
    {
        return new static($id, $productTicket->target->offer($id), $productTicket->source);
    }

    public function hasPrice(): bool
    {
        return $this->price() > 0.0;
    }

    public function price(): float
    {
        return $this->target->price['price'] ?? 0.0;
    }
}
