<?php

namespace App\Core\Elastic\Product\Indexing\Stages;

use App\Core\Elastic\Product\Indexing\Actions\CreateOffersAction;
use App\Core\Elastic\Product\Indexing\Actions\FillPricesAction;
use App\Core\Elastic\Product\Indexing\Actions\FillStocksAction;
use App\Core\Elastic\Product\Indexing\PipelineStageInterface;
use Illuminate\Support\Collection;

class OffersStage implements PipelineStageInterface
{
    public function __construct(
        private CreateOffersAction $createAction,
        private FillStocksAction $stocksAction,
        private FillPricesAction $pricesAction
    ) {
    }

    /**
     * @inheritDoc
     */
    public function execute(Collection $tickets): void
    {
        $offers = $this->createAction->execute($tickets);

        $this->stocksAction->execute($offers);
        $this->pricesAction->execute($offers);
    }
}
