<?php

namespace App\Core\Elastic;

use App\Core\Elastic\Category\CategoryScheduler;
use App\Core\Elastic\Product\ProductScheduler;

class SchedulerFactory
{
    public function scheduler(string $type): ?Scheduler
    {
        switch ($type) {
            case IndexFactory::TYPE_PRODUCT:
                return new ProductScheduler();
            case IndexFactory::TYPE_CATEGORY:
                return new CategoryScheduler();
            default:
                return null;
        }
    }
}
