<?php

namespace App\Core\Rest\Controller;

use App\Core\Rest\RestQuery;
use App\Core\Rest\RestSerializable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;

trait CountAction
{
    use RestAction;

    /**
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     * @todo добавить проарку прав
     */
    public function count(Request $request)
    {
        /** @var Model|RestSerializable $modelClass */
        $modelClass = $this->modelClass();
        $restQuery = new RestQuery($request);

        $pagination = $restQuery->getPage();
        $pageSize = $pagination ? $pagination['limit'] : ReadAction::$PAGE_SIZE;

        $query = $modelClass::modifyQuery($modelClass::query(), $restQuery);
        $total = $query->count();

        $pages = ceil($total / $pageSize);

        return response()->json([
            'total' => $total,
            'pages' => $pages,
            'pageSize' => $pageSize,
        ]);
    }
}
