<?php

namespace App\Core\Rest\Controller;

use Illuminate\Database\Eloquent\Model;
use Symfony\Component\HttpKernel\Exception\HttpException;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

/**
 * Trait DeleteAction - rest-действие для удаления русурса.
 * @package Common\Rest\Controller
 */
trait DeleteAction
{
    use RestAction;

    public function delete(int $id)
    {
        /** @var Model $modelClass */
        $modelClass = $this->modelClass();
        $model = $modelClass::query()->where('id', $id)->first();
        if (!$model) {
            throw new NotFoundHttpException();
        }

        try {
            $ok = $model->delete();
        } catch (\Exception $e) {
            $ok = false;
        }

        if (!$ok) {
            throw new HttpException(500);
        }

        return response('', 204);
    }
}
