<?php

namespace App\Core\Rest\Controller\Validation;

use Illuminate\Contracts\Validation\ImplicitRule;

class RequiredOnPost implements ImplicitRule
{
    /**
     * Determine if the validation rule passes.
     *
     * @param string $attribute
     * @param mixed $value
     * @return bool
     */
    public function passes($attribute, $value)
    {
        return request()->method() == 'POST' ? !empty($value) : true;
    }

    /**
     * Get the validation error message.
     *
     * @return string|array
     */
    public function message()
    {
        return 'The :attribute must be not empty.';
    }
}
