<?php

namespace App\Domain\Categories\Actions\Categories;

use App\Domain\Categories\Models\Category;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class CreateCategoryAction
{
    use AppliesToAggregate;

    public function execute(array $fields): Category
    {
        return $this->updateOrCreate(null, function (Category $category) use ($fields) {
            $category->fill($fields);
        });
    }

    protected function createModel(): Model
    {
        return new Category();
    }
}
