<?php

namespace App\Domain\Categories\Actions\Categories;

use App\Domain\Categories\Models\Category;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class ReplaceCategoryAction
{
    use AppliesToAggregate;

    public function execute(int $categoryId, array $fields): Category
    {
        return $this->updateOrCreate($categoryId, function (Category $category) use ($fields) {
            $category->fill(
                data_combine_assoc($category->getFillable(), $fields)
            );
        });
    }

    protected function createModel(): Model
    {
        return new Category();
    }
}
