<?php

namespace App\Domain\Categories\Actions\Categories;

use App\Domain\Categories\Models\Category;
use App\Domain\Support\Actions\BaseFileAction;
use App\Domain\Support\Models\Model;
use App\Support\Files\FileIntent;
use Illuminate\Http\UploadedFile;

class SaveCategoryImageAction extends BaseFileAction
{
    public function execute(int $categoryId, ?UploadedFile $file): Category
    {
        $intent = $this->createIntent($categoryId, $file);
        return $this->attach($categoryId, $intent, 'file');
    }

    protected function createIntent(int $entityId, UploadedFile $file): FileIntent
    {
        return FileIntent::create($file)
            ->inDirectory('categories')
            ->withNamePrefix("category_$entityId");
    }

    protected function createModel(): Model
    {
        return new Category();
    }
}
