<?php

namespace App\Domain\Categories\Actions\DirectoryValues;

use App\Domain\Categories\Models\Property;
use App\Domain\Categories\Models\PropertyDirectoryValue;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class CreateDirectoryValueAction
{
    use AppliesToAggregate;

    public function execute(int $propertyId, array $fields): PropertyDirectoryValue
    {
        return $this->apply($propertyId, function (Property $property) use ($fields) {
            $value = new PropertyDirectoryValue();
            $value->fill($fields);

            $this->saveRelatedOrThrow($property->directory(), $value);

            return $value;
        });
    }

    protected function createModel(): Model
    {
        return new Property();
    }
}
