<?php

namespace App\Domain\Categories\Actions\DirectoryValues;

use App\Domain\Categories\Models\Property;
use App\Domain\Categories\Models\PropertyDirectoryValue;

class PatchDirectoryValueAction
{
    use AppliesToDirectory;

    public function execute(int $valueId, array $fields): PropertyDirectoryValue
    {
        return $this->applyToDirectory(
            $valueId,
            fn(Property $property, PropertyDirectoryValue $value) => $this->patchDirectoryValue($value, $fields)
        );
    }

    private function patchDirectoryValue(PropertyDirectoryValue $value, array $fields): PropertyDirectoryValue
    {
        $value->fill($fields);

        $this->saveOrThrow($value);

        return $value;
    }
}
