<?php

namespace App\Domain\Categories\Actions\DirectoryValues;

use App\Domain\Categories\Models\Property;
use App\Domain\Categories\Models\PropertyDirectoryValue;

class ReplaceDirectoryValueAction
{
    use AppliesToDirectory;

    public function execute(int $valueId, array $fields): PropertyDirectoryValue
    {
        return $this->applyToDirectory(
            $valueId,
            fn(Property $property, PropertyDirectoryValue $value) => $this->replaceDirectoryValue($value, $fields)
        );
    }

    private function replaceDirectoryValue(PropertyDirectoryValue $value, array $fields): PropertyDirectoryValue
    {
        $value->fill(data_combine_assoc($value->getFillable(), $fields));

        $this->saveOrThrow($value);

        return $value;
    }
}
