<?php

namespace App\Domain\Categories\Actions\Properties;

use App\Domain\Categories\Models\Property;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class PatchPropertyAction
{
    use AppliesToAggregate;

    public function execute(int $propertyId, array $fields): Property
    {
        return $this->updateOrCreate($propertyId, function (Property $property) use ($fields) {
            $property->fill($fields);
        });
    }

    protected function createModel(): Model
    {
        return new Property();
    }
}
