<?php

namespace App\Domain\Classifiers\Actions\Brands;

use App\Domain\Classifiers\Models\Brand;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class CreateBrandAction
{
    use AppliesToAggregate;

    public function execute(array $fields): Brand
    {
        return $this->updateOrCreate(null, function (Brand $brand) use ($fields) {
            $brand->fill($fields);
        });
    }

    protected function createModel(): Model
    {
        return new Brand();
    }
}
