<?php

namespace App\Domain\Classifiers\Actions\Brands;

use App\Domain\Classifiers\Models\Brand;
use App\Domain\Support\Actions\BaseFileAction;
use App\Domain\Support\Models\Model;

class DeleteBrandImageAction extends BaseFileAction
{
    public function execute(int $brandId): Brand
    {
        $this->detach($brandId, 'file');
        return Brand::findOrFail($brandId);
    }

    protected function createModel(): Model
    {
        return new Brand();
    }
}
