<?php

namespace App\Domain\Classifiers\Actions\Brands;

use App\Domain\Classifiers\Models\Brand;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class ReplaceBrandAction
{
    use AppliesToAggregate;

    public function execute(int $brandId, array $fields): Brand
    {
        return $this->updateOrCreate($brandId, function (Brand $brand) use ($fields) {
            $brand->fill(
                data_combine_assoc($brand->getFillable(), $fields)
            );
        });
    }

    protected function createModel(): Model
    {
        return new Brand();
    }
}
