<?php

namespace App\Domain\Classifiers\Actions\Brands;

use App\Domain\Classifiers\Models\Brand;
use App\Domain\Support\Actions\BaseFileAction;
use App\Domain\Support\Models\Model;
use App\Support\Files\FileIntent;
use Illuminate\Http\UploadedFile;

class SaveBrandImageAction extends BaseFileAction
{
    public function execute(int $brandId, ?UploadedFile $file): Brand
    {
        $intent = $this->createIntent($brandId, $file);
        return $this->attach($brandId, $intent, 'file');
    }

    protected function createIntent(int $entityId, UploadedFile $file): FileIntent
    {
        return FileIntent::create($file)
            ->inDirectory('brands')
            ->withNamePrefix("brand_$entityId");
    }

    protected function createModel(): Model
    {
        return new Brand();
    }
}
