<?php

namespace App\Domain\Classifiers\Actions\Countries;

use App\Domain\Support\Concerns\HandlesMassOperation;

class DeleteManyCountriesAction
{
    use HandlesMassOperation;

    public function __construct(private DeleteCountryAction $deleteAction)
    {
    }

    public function execute(array $countryIds): void
    {
        $this->each($countryIds, function (int $countryId) {
            $this->deleteAction->execute($countryId);
        });
    }
}
