<?php

namespace App\Domain\Classifiers\Actions\Countries;

use App\Domain\Classifiers\Models\Country;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class ReplaceCountryAction
{
    use AppliesToAggregate;

    public function execute(int $countryId, array $fields): Country
    {
        return $this->updateOrCreate($countryId, function (Country $country) use ($fields) {
            $country->fill(
                data_combine_assoc($country->getFillable(), $fields)
            );
        });
    }

    protected function createModel(): Model
    {
        return new Country();
    }
}
