<?php

namespace App\Domain\Classifiers\Actions\Manufacturers;

use App\Domain\Classifiers\Models\Manufacturer;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class CreateManufacturerAction
{
    use AppliesToAggregate;

    public function execute(array $fields): Manufacturer
    {
        return $this->updateOrCreate(null, function (Manufacturer $manufacturer) use ($fields) {
            $manufacturer->fill($fields);
        });
    }

    protected function createModel(): Model
    {
        return new Manufacturer();
    }
}
