<?php

namespace App\Domain\Classifiers\Actions\Manufacturers;

use App\Domain\Support\Concerns\HandlesMassOperation;

class DeleteManyManufacturersAction
{
    use HandlesMassOperation;

    public function __construct(private DeleteManufacturerAction $deleteAction)
    {
    }

    public function execute(array $manufacturerIds): void
    {
        $this->each($manufacturerIds, function (int $manufacturerId) {
            $this->deleteAction->execute($manufacturerId);
        });
    }
}
