<?php

namespace App\Domain\Classifiers\Actions\Manufacturers;

use App\Domain\Classifiers\Models\Manufacturer;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class ReplaceManufacturerAction
{
    use AppliesToAggregate;

    public function execute(int $manufacturerId, array $fields): Manufacturer
    {
        return $this->updateOrCreate($manufacturerId, function (Manufacturer $manufacturer) use ($fields) {
            $manufacturer->fill(
                data_combine_assoc($manufacturer->getFillable(), $fields)
            );
        });
    }

    protected function createModel(): Model
    {
        return new Manufacturer();
    }
}
