<?php

namespace App\Domain\Classifiers\Actions\ProductTypes;

use App\Domain\Support\Concerns\HandlesMassOperation;

class DeleteManyProductTypesAction
{
    use HandlesMassOperation;

    public function __construct(private DeleteProductTypeAction $deleteAction)
    {
    }

    public function execute(array $typeIds): void
    {
        $this->each($typeIds, function (int $productTypeId) {
            $this->deleteAction->execute($productTypeId);
        });
    }
}
