<?php

namespace App\Domain\Classifiers\Actions\ProductTypes;

use App\Domain\Classifiers\Models\ProductType;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class PatchProductTypeAction
{
    use AppliesToAggregate;

    public function execute(int $productTypeId, array $fields): ProductType
    {
        return $this->updateOrCreate($productTypeId, function (ProductType $productType) use ($fields) {
            $productType->fill($fields);
        });
    }

    protected function createModel(): Model
    {
        return new ProductType();
    }
}
