<?php

namespace App\Domain\Classifiers\Models;

use App\Domain\Support\Models\Model;
use Database\Factories\Classifiers\CountriesFactory;

/**
 * Country - данные о стране-производителе.
 *
 * @property string $name - название страны
 * @property string $code - код страны
 */
class Country extends Model
{
    const FILLABLE = ['name', 'code'];

    protected $table = 'countries';
    protected $fillable = self::FILLABLE;

    public static function factory(): CountriesFactory
    {
        return CountriesFactory::new();
    }
}
