<?php

namespace App\Domain\Classifiers\Models;

use App\Domain\Support\Models\Model;
use Database\Factories\Classifiers\ManufacturersFactory;

/**
 * Manufacturer - данные о производителе товаров.
 *
 * @property string $name - название производителя
 * @property string $code - код производителя
 */
class Manufacturer extends Model
{
    const FILLABLE = ['name', 'code'];

    protected $table = 'manufacturers';
    protected $fillable = self::FILLABLE;

    public static function factory(): ManufacturersFactory
    {
        return ManufacturersFactory::new();
    }
}
