<?php

namespace App\Domain\Classifiers\Models;

use App\Domain\Support\Models\Model;
use Database\Factories\Classifiers\ProductTypesFactory;

/**
 * ProductType - тип товара.
 * Представляет собой справочник со значениями типа "штучный", "весовой" и т.д.
 *
 * @property string $name - название типа, например "весовой"
 * @property string $code - код типа, например "per_kilo"
 */
class ProductType extends Model
{
    const FILLABLE = ['name', 'code'];

    protected $table = 'product_types';
    protected $fillable = self::FILLABLE;

    public static function factory(): ProductTypesFactory
    {
        return ProductTypesFactory::new();
    }
}
