<?php

namespace App\Domain\Products\Actions\Images;

use App\Domain\Products\Models\Product;
use App\Domain\Products\Models\ProductImage;
use App\Domain\Support\Actions\BaseFileAction;
use App\Domain\Support\Models\Model;

class DeleteProductImageAction extends BaseFileAction
{
    public function execute(int $imageId): void
    {
        // Загружаем в неявной транзакции, чтобы удаление картинки выполнялось в отдельной
        $image = ProductImage::findOrFail($imageId);

        $this->deleteImage($image);
    }

    protected function deleteImage(ProductImage $image): void
    {
        $this->detach($image->product_id, function () use ($image) {
            $oldFilePath = $image->file;
            $this->deleteOrThrow($image);

            return $oldFilePath;
        });
    }

    protected function createModel(): Model
    {
        return new Product();
    }

}
