<?php

namespace App\Domain\Products\Actions\Products;

use App\Domain\Products\Models\Product;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class CreateProductAction
{
    use AppliesToAggregate;

    public function execute(array $fields): Product
    {
        return $this->updateOrCreate(null, function (Product $product) use ($fields) {
            $product->fill($fields);
        });
    }

    protected function createModel(): Model
    {
        return new Product();
    }
}
