<?php

namespace App\Domain\Products\Actions\Products;

use App\Domain\Products\Models\Product;
use App\Domain\Support\Concerns\AppliesToAggregate;
use App\Domain\Support\Models\Model;

class PatchProductAction
{
    use AppliesToAggregate;

    public function execute(int $productId, array $fields): Product
    {
        return $this->updateOrCreate($productId, function (Product $product) use ($fields) {
            $product->fill($fields);
        });
    }

    protected function createModel(): Model
    {
        return new Product();
    }
}
