<?php

namespace App\Http\ApiV1\Modules\Categories\Queries;

use App\Domain\Categories\Models\CategoryPropertyView;
use Illuminate\Http\Request;
use Spatie\QueryBuilder\AllowedFilter;
use Spatie\QueryBuilder\QueryBuilder;

class CategoryPropertiesQueryFactory
{
    public function createQuery(int $categoryId, ?Request $request = null): QueryBuilder
    {
        $initialQuery = CategoryPropertyView::forCategory($categoryId);

        return (new QueryBuilder($initialQuery, $request))
            ->allowedFilters([
                AllowedFilter::exact('type'),
                AllowedFilter::exact('is_filterable'),
                AllowedFilter::exact('is_required', 'link.is_required'),
                AllowedFilter::exact('is_inherited', 'link.is_inherited'),
            ])->allowedIncludes([
                'directory',
            ]);
    }
}
