<?php

namespace App\Http\ApiV1\Modules\Categories\Requests;

use App\Domain\Categories\Models\PropertyType;
use App\Http\ApiV1\Support\Requests\BaseFormRequest;
use BenSampo\Enum\Rules\EnumValue;

class PatchPropertyRequest extends BaseFormRequest
{
    public function rules(): array
    {
        return [
            'name' => ['sometimes', 'required', 'string'],
            'type' => ['sometimes', 'required', new EnumValue(PropertyType::class)],
            'display_name' => ['sometimes', 'required', 'string'],
            'code' => ['sometimes', 'nullable', 'string'],
            'is_multiple' => ['sometimes', 'boolean'],
            'is_filterable' => ['sometimes', 'boolean'],
            'is_color' => ['sometimes', 'boolean'],
        ];
    }
}
