<?php

namespace App\Http\ApiV1\Modules\Categories\Resources;

use App\Domain\Categories\Models\Property;
use App\Domain\Categories\Models\PropertyType;
use App\Http\ApiV1\Support\Resources\BaseJsonResource;

/**
 * @mixin Property
 */
class PropertiesResource extends BaseJsonResource
{
    public function toArray($request): array
    {
        return [
            'id' => $this->id,
            'code' => $this->code,
            'name' => $this->name,
            'display_name' => $this->display_name,
            'type' => $this->type,
            'is_multiple' => $this->is_multiple,
            'is_filterable' => $this->is_filterable,
            'is_color' => $this->is_color,

            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,

            'directory' => $this->when(
                $this->isDirectoryLoaded(),
                fn() => AttributeDirectoryValuesResource::collection($this->directory)
            ),
        ];
    }

    private function isDirectoryLoaded(): bool
    {
        return $this->type->is(PropertyType::DIRECTORY()) && $this->relationLoaded('directory');
    }
}
