<?php

use App\Http\ApiV1\Modules\Categories\Controllers\CategoriesController;
use App\Http\ApiV1\Modules\Categories\Controllers\DirectoryValuesController;
use App\Http\ApiV1\Modules\Categories\Controllers\PropertiesController;
use Illuminate\Support\Facades\Route;

//region Categories
Route::post('categories', [CategoriesController::class, 'create'])->name('createCategory');

Route::prefix('categories/{entityId}')
    ->group(function () {
        Route::get('', [CategoriesController::class, 'get'])->name('getCategory');
        Route::put('', [CategoriesController::class, 'replace'])->name('replaceCategory');
        Route::patch('', [CategoriesController::class, 'patch'])->name('patchCategory');
        Route::delete('', [CategoriesController::class, 'delete'])->name('deleteCategory');
    });

Route::post('categories:search', [CategoriesController::class, 'search'])
    ->name('searchCategories');
Route::post('categories:tree', [CategoriesController::class, 'tree'])
    ->name('getCategoriesTree');

Route::post('categories:mass-delete', [CategoriesController::class, 'massDelete'])
    ->name('deleteCategories');

Route::post('categories/{entityId}:upload-image', [CategoriesController::class, 'uploadImage'])
    ->name('uploadCategoryImage');

Route::post('categories/{entityId}:delete-image', [CategoriesController::class, 'deleteImage'])
    ->name('deleteCategoryImage');

Route::post('categories/{entityId}:properties', [CategoriesController::class, 'properties'])
    ->name('getCategoryProperties');
//endregion

//region Properties
Route::post('properties', [PropertiesController::class, 'create'])->name('createProperty');

Route::prefix('properties/{entityId}')
    ->group(function () {
        Route::get('', [PropertiesController::class, 'get'])->name('getProperty');
        Route::put('', [PropertiesController::class, 'replace'])->name('replaceProperty');
        Route::patch('', [PropertiesController::class, 'patch'])->name('patchProperty');
        Route::delete('', [PropertiesController::class, 'delete'])->name('deleteProperty');
    });

Route::post('properties:search', [PropertiesController::class, 'search'])
    ->name('searchProperties');

Route::post('properties:mass-delete', [PropertiesController::class, 'massDelete'])
    ->name('deleteProperties');
//endregion

//region Directory values
Route::post('properties/{entityId}:add-directory', [DirectoryValuesController::class, 'create'])
    ->name('createDirectoryValue');

Route::prefix('properties/directory/{entityId}')
    ->group(function () {
        Route::get('', [DirectoryValuesController::class, 'get'])->name('getDirectoryValue');
        Route::put('', [DirectoryValuesController::class, 'replace'])->name('replaceDirectoryValue');
        Route::patch('', [DirectoryValuesController::class, 'patch'])->name('patchDirectoryValue');
        Route::delete('', [DirectoryValuesController::class, 'delete'])->name('deleteDirectoryValue');
    });

Route::post('properties/directory:search', [DirectoryValuesController::class, 'search'])
    ->name('searchDirectoryValues');
//endregion
