<?php

use App\Http\ApiV1\Modules\Classifiers\Controllers\BrandsController;
use App\Http\ApiV1\Modules\Classifiers\Controllers\CountriesController;
use App\Http\ApiV1\Modules\Classifiers\Controllers\ManufacturersController;
use App\Http\ApiV1\Modules\Classifiers\Controllers\ProductTypesController;
use Illuminate\Support\Facades\Route;

//region Manufacturers
Route::post('manufacturers', [ManufacturersController::class, 'create'])->name('createManufacturer');

Route::prefix('manufacturers/{entityId}')
    ->group(function () {
        Route::get('', [ManufacturersController::class, 'get'])->name('getManufacturer');
        Route::put('', [ManufacturersController::class, 'replace'])->name('replaceManufacturer');
        Route::patch('', [ManufacturersController::class, 'patch'])->name('patchManufacturer');
        Route::delete('', [ManufacturersController::class, 'delete'])->name('deleteManufacturer');
    });

Route::post('manufacturers:search', [ManufacturersController::class, 'search'])
    ->name('searchManufacturers');

Route::post('manufacturers:mass-delete', [ManufacturersController::class, 'massDelete'])
    ->name('deleteManufacturers');
//endregion

//region Countries
Route::post('countries', [CountriesController::class, 'create'])->name('createCountry');

Route::prefix('countries/{entityId}')
    ->group(function () {
        Route::get('', [CountriesController::class, 'get'])->name('getCountry');
        Route::put('', [CountriesController::class, 'replace'])->name('replaceCountry');
        Route::patch('', [CountriesController::class, 'patch'])->name('patchCountry');
        Route::delete('', [CountriesController::class, 'delete'])->name('deleteCountry');
    });

Route::post('countries:search', [CountriesController::class, 'search'])
    ->name('searchCountries');

Route::post('countries:mass-delete', [CountriesController::class, 'massDelete'])
    ->name('deleteCountries');
//endregion

//region Product types
Route::post('product-types', [ProductTypesController::class, 'create'])->name('createProductType');

Route::prefix('product-types/{entityId}')
    ->group(function () {
        Route::get('', [ProductTypesController::class, 'get'])->name('getProductType');
        Route::put('', [ProductTypesController::class, 'replace'])->name('replaceProductType');
        Route::patch('', [ProductTypesController::class, 'patch'])->name('patchProductType');
        Route::delete('', [ProductTypesController::class, 'delete'])->name('deleteProductType');
    });

Route::post('product-types:search', [ProductTypesController::class, 'search'])
    ->name('searchProductTypes');

Route::post('product-types:mass-delete', [ProductTypesController::class, 'massDelete'])
    ->name('deleteProductTypes');
//endregion

//region Brands
Route::post('brands', [BrandsController::class, 'create'])->name('createBrand');

Route::prefix('brands/{entityId}')
    ->group(function () {
        Route::get('', [BrandsController::class, 'get'])->name('getBrand');
        Route::put('', [BrandsController::class, 'replace'])->name('replaceBrand');
        Route::patch('', [BrandsController::class, 'patch'])->name('patchBrand');
        Route::delete('', [BrandsController::class, 'delete'])->name('deleteBrand');
    });

Route::post('brands:search', [BrandsController::class, 'search'])
    ->name('searchBrands');

Route::post('brands:mass-delete', [BrandsController::class, 'massDelete'])
    ->name('deleteBrands');

Route::post('brands/{entityId}:upload-image', [BrandsController::class, 'uploadImage'])
    ->name('uploadBrandImage');

Route::post('brands/{entityId}:delete-image', [BrandsController::class, 'deleteImage'])
    ->name('deleteBrandImage');
//endregion
