<?php

namespace App\Http\ApiV1\Modules\Products\Queries;

use App\Domain\Products\Models\Product;
use Illuminate\Http\Request;
use Laravie\SerializesQuery\Eloquent;
use Spatie\QueryBuilder\AllowedFilter;
use Spatie\QueryBuilder\QueryBuilder;

class FilterProductsQuery extends QueryBuilder
{
    public function __construct(Request $request)
    {
        parent::__construct(Product::query(), $request);

        $this->allowedFilters([
            AllowedFilter::exact('id'),
            AllowedFilter::exact('code'),
            AllowedFilter::partial('name'),
            AllowedFilter::scope('category_id', 'in_categories'),
            AllowedFilter::exact('brand_id'),
            AllowedFilter::exact('product_type_id'),
            AllowedFilter::exact('archive'),
        ]);
    }

    public function serialize(): array
    {
        return Eloquent::serialize($this->getEloquentBuilder());
    }
}
