<?php

namespace App\Http\ApiV1\Modules\Products\Queries;

use App\Domain\Products\Models\ProductImage;
use Spatie\QueryBuilder\AllowedFilter;
use Spatie\QueryBuilder\QueryBuilder;

class ProductImagesQuery extends QueryBuilder
{
    public function __construct()
    {
        parent::__construct(ProductImage::query());

        $this->allowedSorts(['id', 'type', 'product_id']);
        $this->defaultSort('id');

        $this->allowedFilters([
            AllowedFilter::exact('id'),
            AllowedFilter::exact('type'),
            AllowedFilter::exact('product_id'),
        ]);
    }
}
