<?php

namespace App\Http\ApiV1\Modules\Products\Requests;

use App\Domain\Products\Models\Product;
use App\Domain\Products\Models\ProductImageType;
use App\Http\ApiV1\Support\Requests\BaseFormRequest;
use BenSampo\Enum\Rules\EnumValue;
use Illuminate\Validation\Rule;

class CreateProductImageRequest extends BaseFormRequest
{
    public function rules(): array
    {
        return [
            'product_id' => ['required', Rule::exists(Product::class, 'id')],
            'type' => ['required', new EnumValue(ProductImageType::class)],
        ];
    }
}
