<?php

namespace App\Models;

use App\Core\Rest\Eloquent\AbstractRestModel;
use App\Domain\Products\Models\Product;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

/**
 * Class ProductConstraint
 * @package App\Models
 *
 * @property int $id
 * @property int $product_id
 * @property int $type
 * @property string $value
 * @property bool $deny
 *
 * @property-read Product $product
 */
class ProductConstraint extends AbstractRestModel
{
    public const DELIVERY_METHOD = 1;
    public const DELIVERY_SERVICE = 2;
    public const RETURN_METHOD = 3;
    public const PAYMENT_METHOD = 4;

    public $timestamps = false;
    protected static $unguarded = true;

    public function product(): BelongsTo
    {
        return $this->belongsTo(Product::class);
    }
}
