<?php

namespace App\Models;

use App\Domain\Products\Models\Product;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

/**
 * Class ProductTip
 * @package App\Models
 *
 * @property int $product_id
 * @property string $file
 * @property string $description
 * @property int $sort
 *
 * @property-read Product $product
 */
class ProductTip extends PimModel
{
    public function product(): BelongsTo
    {
        return $this->belongsTo(Product::class);
    }
}
