<?php

namespace App\Observers;

use App\Core\Elastic\IndexFactory;
use App\Core\Elastic\ScheduleRunner;
use App\Domain\Products\Models\ProductImage;

class ProductImageObserver
{
    protected $scheduler;

    public function __construct(ScheduleRunner $scheduler)
    {
        $this->scheduler = $scheduler;
    }

    /**
     * Handle the model "created" event.
     *
     * @param ProductImage $productImage
     * @return void
     */
    public function created(ProductImage $productImage)
    {
        $this->scheduler->markForIndex(IndexFactory::TYPE_PRODUCT, $productImage->product_id);
    }

    /**
     * Handle the model "deleted" event.
     *
     * @param ProductImage $productImage
     * @return void
     */
    public function deleted(ProductImage $productImage)
    {
        $this->scheduler->markForIndex(IndexFactory::TYPE_PRODUCT, $productImage->product_id);
    }
}
