<?php

namespace App\Observers;

use App\Models\ProductTip;
use Ensi\LaravelEnsiFilesystem\EnsiFilesystemManager;
use Storage;

class ProductTipObserver
{
    public function __construct(protected EnsiFilesystemManager $filesystemManager)
    {
    }

    public function deleted(ProductTip $productTip)
    {
        if ($productTip->file) {
            Storage::disk($this->filesystemManager->publicDiskName())->delete($productTip->file);
        }
    }
}
