<?php

use Illuminate\Support\Arr;

/**
 * Возвращает первое непустое значение.
 *
 * @param mixed ...$values
 * @return mixed|null
 */
function coalesce(...$values)
{
    foreach ($values as $value) {
        if (!blank($value)) {
            return $value;
        }
    }
    return null;
}

/**
 * Создает массив с ключами $keys. Значения ищутся по ключу в массиве $values.
 * Если значение не найдено, то подставляется $defaultValue.
 *
 * @param array $keys
 * @param array $values
 * @param null|mixed $defaultValue
 * @return array
 */
function data_combine_assoc(array $keys, array $values, $defaultValue = null): array
{
    return array_replace(
        array_fill_keys($keys, $defaultValue),
        Arr::only($values, $keys)
    );
}
