<?php

namespace Database\Factories\Categories;

use App\Domain\Categories\Models\Property;
use App\Domain\Categories\Models\PropertyDirectoryValue;
use Database\Factories\Factory;
use Illuminate\Support\Collection;

/**
 * @method PropertyDirectoryValue createOne(array $fields = [])
 * @method PropertyDirectoryValue makeOne(array $fields = [])
 * @method PropertyDirectoryValue|PropertyDirectoryValue[]|Collection create(array $fields = [], $parent = null)
 */
class DirectoryValueFactory extends Factory
{
    protected $model = PropertyDirectoryValue::class;

    public function definition(): array
    {
        return [
            'name' => $this->faker->word,
            'code' => $this->faker->slug(1),
        ];
    }

    public function forProperty(int|Property $property): self
    {
        $propertyId = is_int($property) ? $property : $property->getKey();
        return $this->state(fn() => ['property_id' => $propertyId]);
    }
}
