<?php

namespace Database\Factories\Categories;

use App\Domain\Categories\Models\Property;
use App\Domain\Categories\Models\PropertyType;
use Database\Factories\Factory;
use Illuminate\Support\Collection;

/**
 * @method Property createOne(array $fields = [])
 * @method Property makeOne(array $fields = [])
 * @method Property|Property[]|Collection create(array $fields = [], $parent = null)
 */
class PropertiesFactory extends Factory
{
    protected $model = Property::class;

    public function definition(): array
    {
        return [
            'name' => $this->faker->word,
            'display_name' => $this->faker->word,
            'code' => $this->faker->unique()->slug(1),
            'type' => PropertyType::getRandomInstance(),
            'is_multiple' => $this->faker->boolean,
            'is_filterable' => $this->faker->boolean,
            'is_color' => false,
        ];
    }

    public function directory(): self
    {
        return $this->state(['type' => PropertyType::DIRECTORY]);
    }
}
