<?php

namespace Database\Factories\Classifiers;

use App\Domain\Classifiers\Models\Brand;
use Database\Factories\Factory;
use Illuminate\Support\Collection;

/**
 * @method Brand createOne(array $fields = [])
 * @method Brand makeOne(array $fields = [])
 * @method Brand|Brand[]|Collection create(array $fields = [], $parent = null)
 */
class BrandsFactory extends Factory
{
    protected $model = Brand::class;

    /**
     * @inheritDoc
     */
    public function definition(): array
    {
        return [
            'name' => $this->faker->word,
            'code' => $this->faker->slug(1),
            'description' => $this->faker->text,
        ];
    }
}
