<?php

namespace Database\Factories\Classifiers;

use App\Domain\Classifiers\Models\Country;
use Database\Factories\Factory;
use Illuminate\Support\Collection;

/**
 * @method Country createOne(array $fields = [])
 * @method Country makeOne(array $fields = [])
 * @method Country|Country[]|Collection create(array $fields = [], $parent = null)
 */
class CountriesFactory extends Factory
{
    protected $model = Country::class;

    /**
     * @inheritDoc
     */
    public function definition(): array
    {
        return [
            'code' => $this->faker->slug,
            'name' => $this->faker->country,
        ];
    }
}
