<?php

namespace Database\Factories;

use Illuminate\Database\Eloquent\Factories\Factory as EloquentFactory;
use Illuminate\Support\Arr;

abstract class Factory extends EloquentFactory
{
    /**
     * Возвращает массив значений атрибутов, разрешенных для массового заполнения.
     *
     * @param array $fields
     * @return array
     */
    public function makeFillableData(array $fields = []): array
    {
        $model = $this->makeOne($fields);
        return Arr::only($model->getAttributes(), $model->getFillable());
    }
}
