<?php

namespace Database\Factories\Products;

use App\Domain\Products\Models\Product;
use App\Domain\Products\Models\ProductImage;
use App\Domain\Products\Models\ProductImageType;
use Database\Factories\Factory;
use Illuminate\Support\Collection;

/**
 * @method ProductImage createOne(array $fields = [])
 * @method ProductImage makeOne(array $fields = [])
 * @method ProductImage|ProductImage[]|Collection create(array $fields = [], $parent = null)
 */
class ProductImagesFactory extends Factory
{
    protected $model = ProductImage::class;

    public function definition(): array
    {
        $fileId = $this->faker->unique()->numberBetween(100, 999);

        return [
            'type' => ProductImageType::getRandomInstance(),
            'file' => "path/to/image_{$fileId}.png",
        ];
    }

    public function owned(Product $product): self
    {
        return $this->state(function () use ($product) {
            return [
                'product_id' => $product->getKey(),
            ];
        });
    }
}
