<?php

namespace Tests\Integration\Elastic\Products\Actions;

use App\Core\Elastic\Product\Indexing\OfferTicket;
use App\Core\Elastic\Product\Indexing\ProductTicket;
use App\Core\Elastic\Product\OfferIndexProperty;
use App\Core\Elastic\Product\ProductIndexRecord;
use App\Domain\Products\Models\Product;
use Tests\TestCase;

abstract class OffersActionTestCase extends TestCase
{
    protected function createOffer(int $id): OfferIndexProperty
    {
        $offer = new OfferIndexProperty();
        $offer->offerId = $id;
        return $offer;
    }

    protected function createProductTicket(int $id): ProductTicket
    {
        $product = new Product();
        $product->id = $id;

        return new ProductTicket($id, new ProductIndexRecord(), $product);
    }

    protected function createOfferTicket(int $id, ?int $price = null): OfferTicket
    {
        $target = $this->createOffer($id);

        if ($price !== null) {
            $target->setPrice(['price' => $price, 'cost' => $price]);
        }

        return new OfferTicket($id, $target, new Product());
    }
}
